// Capsule5.js
// 5-10-2018
// Pour p5.js (Processing en JavaScript)
// OK Processing v 3.3.7 en mode p5.js
//
// Utilise la library p5.js
// Utilise la library p5.sound.js
// Utilise la library p5.dom.js
// Utilise la library socket.io-1.4.5.js
//
// En local: OK Firefox 62  
// En local: Problem Chrome 69  Safari 12  Opera 56 "Cross origin requests are only supported for HTTP."
// En ligne OK  MacOSX: Firefox 62  Chrome 69  Safari 12  Opera 56 
// En ligne OK Android: Firefox 62  Chrome 69  
//
// https://p5js.org/reference/#/p5.SoundFile
// https://p5js.org/reference/#/p5.Amplitude
// https://socket.io/blog/socket-io-1-4-5/
//

var AdresseServeur = 'http://192.168.1.20:3000'; 
var NomSon1 = "cemuhi-12s.mp3";
var NomSon2 = "LeHeron.mp3";
var NomSon = NomSon1;
var NomSonDistant = NomSon1;

var Son;
var DureeSon = 0;
var rms = 0;
var Bord = 50; // pixels
var socket;
var NbrPlayServer = 0;
var Bouton = new Array(6);
var Reception = "Rien pour l'instant";
var MenuLocal, MenuDistant;
var Progress = 0;

function preload() {
  Son = loadSound(NomSon);
  // ChargeSon();
  print('Fin preload');
}

function setup() {
  // createCanvas(windowWidth, windowHeight);
  Canevas = createCanvas(500, 500);
  Canevas.position(Bord, Bord);

  CouleurVerte = color(50, 150, 50);

  Texte1 = createElement('h2', '');
  Texte1.position(20, -10);
  Texte1.html('Capsule5.js');

  MenuLocal = createSelect();
  MenuLocal.position(370, Bord + 167);
  MenuLocal.option(NomSon1);
  MenuLocal.option(NomSon2);
  // MenuLocal.option('  ..  ');
  MenuLocal.style('font-size', '16px');
  MenuLocal.size(180, 30);
  MenuLocal.changed(MenuLocalEvent);

  MenuDistant = createSelect();
  MenuDistant.position(370, Bord + 167 + 40);
  MenuDistant.option(NomSon1);
  MenuDistant.option(NomSon2);
  // MenuDistant.option('  ..  ');
  MenuDistant.style('font-size', '16px');
  MenuDistant.size(180, 30);
  MenuDistant.changed(MenuDistantEvent);

  for (var i = 0; i < Bouton.length; i++) {
    Bouton[i] = createButton('Play');
    Bouton[i].style('background-color', CouleurVerte);
    Bouton[i].style('color', color(255, 255, 255));
    Bouton[i].style('font-size', '16px');
    Bouton[i].style('border', 'none');
    Bouton[i].style('border-radius', '6px');
    Bouton[i].position(Bord + 85 + (i%3 * 80), Bord + 165 + int(i/3)*40);
    Bouton[i].size(70, 30);
  }
  Bouton[0].html('Play');
  Bouton[0].mouseClicked(ClicBoutonPlayLocal);
  Bouton[1].html('Pause');
  Bouton[1].mouseClicked(ClicBoutonPauseLocal);
  Bouton[2].html('Stop');
  Bouton[2].mouseClicked(ClicBoutonStopLocal);
  Bouton[3].html('Play');
  Bouton[3].mouseClicked(ClicBoutonPlayServer);
  Bouton[4].html('Pause');
  Bouton[4].mouseClicked(ClicBoutonPauseServer);
  Bouton[5].html('Stop');
  Bouton[5].mouseClicked(ClicBoutonStopServer);

  DureeSon = Son.duration();
  analyse = new p5.Amplitude(); // create a new Amplitude analyse
  analyse.setInput(Son);

  if (true) {
    socket = io.connect(AdresseServeur); // Start a socket connection to the server
    // We make a named event called 'PlayFile1' and write an anonymous callback function
    socket.on('PlayFile1', // When we receive data
      function(data) {
      Reception = data.x;
      console.log("Got: " + data.x);
      NbrPlayServer = NbrPlayServer + 1;
      if (Reception == 'Play') Son.play();
      else if (Reception == 'Pause') Son.pause();
      else if (Reception == 'Stop') Son.stop();
      else {
        NomSon = Reception;
        ChargeSon();
      }
    }
    );
  }
  print('Fin setup');
}

function draw() {
  background(230);
  fill(255);
  rect(180, 252, 300, 14);
  fill(CouleurVerte);
  textAlign(LEFT);
  textSize(18);
  text('File: ' + NomSon, 20, 20);
  text("Duration: " + int(DureeSon * 10) / 10 + " seconds", 20, 40);
  // text("Zut ", 20, 40);
  text("Channels: " + Son.channels(), 20, 60);
  text("SampleRate: " + Son.sampleRate() + " samples / sec", 20, 80);

  text("Time: " + int(Son.currentTime() * 10) / 10 + " seconds", 20, 120);
  if (Son.isPlaying()) rms = int(analyse.getLevel() * 1000);
  text("RMS level: " + rms / 10 + " ", 20, 140);
  rect(150, 132, rms, 14);
  text("Local:", 20, 180);
  text("Distant:", 20, 220);
  text("Chargement: " + Progress, 20, 260);
  rect(180, 252, Progress * 300, 14);
  // text(NbrPlayServer, 420, 320);
  fill(0);
  text("Reception " + NbrPlayServer + ": " + Reception, 20, 320);
  AfficheFrame();
}

function MenuLocalEvent() {
  var item = MenuLocal.value();
  print(item);  
  NomSon =item;
  ChargeSon();
}

function ChargeSon() {
  if (Son.isPlaying()) Son.stop();
  loadSound(NomSon, ChargementOK, ChargementPB, ChargementProgress);
}

function ChargementOK(soundFile) {
  Son = soundFile;
  DureeSon = Son.duration();
  print('ChargementOK');  
  analyse.setInput(Son);
}

function ChargementPB(e) {
  console.log('ChargementPB');  
  console.log('New error:');
  console.log('- name: ' + e.name);
  console.log('- message: ' + e.message);
  console.log('- stack: ' + e.stack);
  console.log('- failed path: ' + e.failedPath);
}

function ChargementProgress(P) {
  Progress = P;
  // Progress = 0.123;
  print('Progress = ' + Progress);
}

function ClicBoutonPlayLocal() {
  Son.play();
  return false; // https://p5js.org/reference/#/p5/mouseClicked
}

function ClicBoutonPauseLocal() {
  Son.pause();
  return false; // https://p5js.org/reference/#/p5/mouseClicked
}

function ClicBoutonStopLocal() {
  Son.stop();
  return false; // https://p5js.org/reference/#/p5/mouseClicked
}

function MenuDistantEvent() {
  var item = MenuDistant.value();
  print(item);  
  NomSonDistant =item;
  MenuDistantEnvoi();
}

function ClicBoutonPlayServer() {
  // NbrPlayServer = NbrPlayServer + 1;
  // Bouton2.html('Play ' + NbrPlayServer);
  // Envoyer('Play ' + NbrPlayServer);
  Envoyer('Play');
}

function ClicBoutonPauseServer() {
  Envoyer('Pause');
}

function ClicBoutonStopServer() {
  Envoyer('Stop');
}

function MenuDistantEnvoi() {
  Envoyer(NomSonDistant);
}

function Envoyer(Message) { // Function for sending to the socket
  console.log("Envoyer: " + Message);
var data = {x: 
  Message
};
socket.emit('PlayFile1', data); // Send that object to the socket
}

function AfficheFrame() {
  var y = height/2 + 200;
  fill(255, 255, 255);
  ellipse(width/2, y, 100, 100);
  textAlign(CENTER, CENTER);
  textSize(25);
  fill(0, 0, 0);
  text("Frame:", width/2, y - 15);
  text(frameCount, width/2, y + 15);
}
